package cn.iocoder.yudao.module.iot.service.alert;

import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;

import javax.annotation.Resource;

import cn.iocoder.yudao.framework.test.core.ut.BaseDbUnitTest;

import cn.iocoder.yudao.module.iot.controller.admin.alert.vo.*;
import cn.iocoder.yudao.module.iot.dal.dataobject.alert.AlertDO;
import cn.iocoder.yudao.module.iot.dal.mysql.alert.AlertMapper;
import cn.iocoder.yudao.framework.common.pojo.PageResult;

import org.springframework.context.annotation.Import;

import static cn.iocoder.yudao.module.iot.enums.ErrorCodeConstants.*;
import static cn.iocoder.yudao.framework.test.core.util.AssertUtils.*;
import static cn.iocoder.yudao.framework.test.core.util.RandomUtils.*;
import static cn.iocoder.yudao.framework.common.util.date.LocalDateTimeUtils.*;
import static cn.iocoder.yudao.framework.common.util.object.ObjectUtils.*;
import static org.junit.jupiter.api.Assertions.*;

/**
 * {@link AlertServiceImpl} 的单元测试类
 *
 * @author 内蒙必硕
 */
@Import(AlertServiceImpl.class)
public class AlertServiceImplTest extends BaseDbUnitTest {

    @Resource
    private AlertServiceImpl alertService;

    @Resource
    private AlertMapper alertMapper;

    @Test
    public void testCreateAlert_success() {
        // 准备参数
        AlertSaveReqVO createReqVO = randomPojo(AlertSaveReqVO.class).setId(null);

        // 调用
        Long alertId = alertService.createAlert(createReqVO);
        // 断言
        assertNotNull(alertId);
        // 校验记录的属性是否正确
        AlertDO alert = alertMapper.selectById(alertId);
        assertPojoEquals(createReqVO, alert, "id");
    }

    @Test
    public void testUpdateAlert_success() {
        // mock 数据
        AlertDO dbAlert = randomPojo(AlertDO.class);
        alertMapper.insert(dbAlert);// @Sql: 先插入出一条存在的数据
        // 准备参数
        AlertSaveReqVO updateReqVO = randomPojo(AlertSaveReqVO.class, o -> {
            o.setId(dbAlert.getId()); // 设置更新的 ID
        });

        // 调用
        alertService.updateAlert(updateReqVO);
        // 校验是否更新正确
        AlertDO alert = alertMapper.selectById(updateReqVO.getId()); // 获取最新的
        assertPojoEquals(updateReqVO, alert);
    }

    @Test
    public void testUpdateAlert_notExists() {
        // 准备参数
        AlertSaveReqVO updateReqVO = randomPojo(AlertSaveReqVO.class);

        // 调用, 并断言异常
        assertServiceException(() -> alertService.updateAlert(updateReqVO), ALERT_NOT_EXISTS);
    }

    @Test
    public void testDeleteAlert_success() {
        // mock 数据
        AlertDO dbAlert = randomPojo(AlertDO.class);
        alertMapper.insert(dbAlert);// @Sql: 先插入出一条存在的数据
        // 准备参数
        Long id = dbAlert.getId();

        // 调用
        alertService.deleteAlert(id);
       // 校验数据不存在了
       assertNull(alertMapper.selectById(id));
    }

    @Test
    public void testDeleteAlert_notExists() {
        // 准备参数
        Long id = randomLongId();

        // 调用, 并断言异常
        assertServiceException(() -> alertService.deleteAlert(id), ALERT_NOT_EXISTS);
    }

    @Test
    @Disabled  // TODO 请修改 null 为需要的值，然后删除 @Disabled 注解
    public void testGetAlertPage() {
       // mock 数据
       AlertDO dbAlert = randomPojo(AlertDO.class, o -> { // 等会查询到
           o.setAlertCode(null);
           o.setAlertName(null);
           o.setAlertType(null);
           o.setAlertLevel(null);
           o.setContent(null);
           o.setConditionInfo(null);
           o.setConditionFormula(null);
           o.setAlertAudio(null);
           o.setIsRepeat(null);
           o.setNoRepeatDuration(null);
           o.setIsEnable(null);
           o.setCreateTime(null);
       });
       alertMapper.insert(dbAlert);
       // 测试 alertCode 不匹配
       alertMapper.insert(cloneIgnoreId(dbAlert, o -> o.setAlertCode(null)));
       // 测试 alertName 不匹配
       alertMapper.insert(cloneIgnoreId(dbAlert, o -> o.setAlertName(null)));
       // 测试 alertType 不匹配
       alertMapper.insert(cloneIgnoreId(dbAlert, o -> o.setAlertType(null)));
       // 测试 alertLevel 不匹配
       alertMapper.insert(cloneIgnoreId(dbAlert, o -> o.setAlertLevel(null)));
       // 测试 content 不匹配
       alertMapper.insert(cloneIgnoreId(dbAlert, o -> o.setContent(null)));
       // 测试 condition 不匹配
       alertMapper.insert(cloneIgnoreId(dbAlert, o -> o.setConditionInfo(null)));
       // 测试 conditionFormula 不匹配
       alertMapper.insert(cloneIgnoreId(dbAlert, o -> o.setConditionFormula(null)));
       // 测试 alertAudio 不匹配
       alertMapper.insert(cloneIgnoreId(dbAlert, o -> o.setAlertAudio(null)));
       // 测试 isRepeat 不匹配
       alertMapper.insert(cloneIgnoreId(dbAlert, o -> o.setIsRepeat(null)));
       // 测试 noRepeatDuration 不匹配
       alertMapper.insert(cloneIgnoreId(dbAlert, o -> o.setNoRepeatDuration(null)));
       // 测试 isEnable 不匹配
       alertMapper.insert(cloneIgnoreId(dbAlert, o -> o.setIsEnable(null)));
       // 测试 createTime 不匹配
       alertMapper.insert(cloneIgnoreId(dbAlert, o -> o.setCreateTime(null)));
       // 准备参数
       AlertPageReqVO reqVO = new AlertPageReqVO();
       reqVO.setAlertCode(null);
       reqVO.setAlertName(null);
       reqVO.setAlertType(null);
       reqVO.setAlertLevel(null);
       reqVO.setContent(null);
       //reqVO.setCondition(null);
       reqVO.setConditionFormula(null);
       reqVO.setAlertAudio(null);
       reqVO.setIsRepeat(null);
       reqVO.setNoRepeatDuration(null);
       reqVO.setIsEnable(null);
       reqVO.setCreateTime(buildBetweenTime(2023, 2, 1, 2023, 2, 28));

       // 调用
       PageResult<AlertDO> pageResult = alertService.getAlertPage(reqVO);
       // 断言
       assertEquals(1, pageResult.getTotal());
       assertEquals(1, pageResult.getList().size());
       assertPojoEquals(dbAlert, pageResult.getList().get(0));
    }

}